#!/usr/local/bin/perl  # no need for this on a dos platform really...
# s2ptoard.pl
# Converts s2p s-parameter files to a format more useful for the ARRL Radio 
# Designer (ARD) 
# command line: s2ptoard inputfile.ext outfilename
# output file (outfilename.ard) will have s-parmeter block named  sparam_
# and will create a two port block referencing this called SPARAM
# Copyright(C) 1997 Lance Lascari
# LL 6/7/97 - 6/8/97
# MOD 6/16/97 trying to mod to allow blank lines...
# some configuration type stuff


# first verify command line and file openings
die("USAGE: s2ptoard [s2pfile.ext} [outputname]\r\n") 
    if( ($ARGV[0] eq "")  || ($ARGV[1] eq "")) ;

unless( open(INFILE,$ARGV[0])) 
{   
    die("can't open input data file $ARGV[0]\r\n");
}
#check output file name length
$len=length($ARGV[1]);
if( $len > 8 )
{
    die("ERROR: I'll only allow you 8 characters in the output file name\n");
}
unless( open(OUTFILE,">".$ARGV[1].".ard"))     # append ".ard" extension
{
     die("can't open output file $ARGV[1]\r\n");
}


# print time in the header file as well as source filename
$tim=time();
$tim=localtime($tim);


printf OUTFILE ("***\n* %s -> %s\n", $ARGV[0], $ARGV[1].".ard");
printf OUTFILE ("*ARD file converted from s2p file by Lance Lascari's Perl program\n*$tim\n***\n");

printf OUTFILE ("** put the next block in the circuit block\n");
printf OUTFILE ("BLK\nTWO 1 2 0 sparam_\nSPARAM: 2POR 1 2 0\nEND\n**\n");

# start writing
printf("S2P -> ARD converter by WS2B\n");
printf("Input File: %s Output File :%s\n",$ARGV[0],  $ARGV[1].".ard");

printf OUTFILE ("DATA\n");                            # beginning of data block
$header=1;
while($header == 1)
{
    $linebuf=<INFILE>;                                # get one line of input
    chop($linebuf);                                   #remove line feed
    $tmp=substr($linebuf,0,1);                        # get first char
    if($tmp ne "")
      {
	  if(($tmp eq "!")|| ($tmp eq "#"))
	  {
	      printf OUTFILE ("*%s\n",$linebuf);      #write these lines out
	      if($tmp eq "#")
	      {
		  $header=0;                          # # is last before data
		  @params=split(" ",$linebuf);        # get frequency info parsed out
		  $freq=@params[1];                   # used later
	      }
	      if($tmp eq "")
	      {
		  printf ("Blank line\n\r");
	      }
	  }
	  else
	  {
	      
	      die("bad news\n");
	  }
      }
    else
    {
	print "BLANK LINE 1\r\n";
    }
}

printf OUTFILE ("sparam_:S\n");                       # beginning of sparams

#while($datablock == 1)


while(($linebuf=<INFILE>) ne "")
{
    chop($linebuf);                                   #remove line feed
    $tmp=substr($linebuf,0,1);                        # get first char
 
    if($tmp ne "")
    {
	if(($tmp eq "!"))       # look for noise parameters
	{
	    printf OUTFILE ("NOI RN\n*%s\n",$linebuf);   #write noise headerout
	}
	else
	{
	    @line=split(" ",$linebuf);
	    printf OUTFILE ("%s  ",@line[0]."$freq");    # write freq column
	    $i=1;
	    while(@line[$i] ne "")                      # go through all fields
	    {
		printf OUTFILE ("%s  ",@line[$i]);
		$i++;
	    }
	    printf OUTFILE ("\n");                       #one line done
	}
	
    }
   else
   {
       print "BLANK LINE 2\r\n";
   }
    
}

printf OUTFILE ("END\n");                            # beginning of data block

close(INFILE);
close(OUTFILE);
printf("\nThe End\n");


